using Microsoft.UI.Xaml;

namespace TestProject
{
    /// <summary>
    ///  
    /// </summary>
    public sealed partial class MainWindow : Window
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - MainWindow()

        /// <summary>
        /// 
        /// </summary>
        public MainWindow()
        {
            InitializeComponent();

            this.playButton.Click      += playButton_Click;
            this.pauseButton.Checked   += pauseButton_Checked;
            this.pauseButton.Unchecked += pauseButton_Unchecked;
            this.stopButton.Click      += stopButton_Click;
            this.reverseButton.Click   += reverseButton_Click;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region Play ư Ŭ óϱ - playButton_Click(sender, e)

        /// <summary>
        /// Play ư Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void playButton_Click(object sender, RoutedEventArgs e)
        {
            this.player.PlaybackRate = 1;

            EnsurePlaying();
        }

        #endregion
        #region Pause ư üũ óϱ - pauseButton_Checked(sender, e)

        /// <summary>
        /// Pause ư üũ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void pauseButton_Checked(object sender, RoutedEventArgs e)
        {
            this.player.Pause();
        }

        #endregion
        #region Pause ư üũ  óϱ - pauseButton_Unchecked(sender, e)

        /// <summary>
        /// Pause ư üũ  óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void pauseButton_Unchecked(object sender, RoutedEventArgs e)
        {
            this.player.Resume();
        }

        #endregion
        #region Stop ư Ŭ óϱ - stopButton_Click(sender, e)

        /// <summary>
        /// Stop ư Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void stopButton_Click(object sender, RoutedEventArgs e)
        {
            this.player.Stop();

            this.pauseButton.IsChecked = false;
        }

        #endregion
        #region Reverse ư Ŭ óϱ - reverseButton_Click(sender, e)

        /// <summary>
        /// Reverse ư Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void reverseButton_Click(object sender, RoutedEventArgs e)
        {
            this.player.PlaybackRate = -1;

            EnsurePlaying();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Function

        #region  ϱ - EnsurePlaying()

        /// <summary>
        ///  ϱ
        /// </summary>
        private void EnsurePlaying()
        {
            if(this.pauseButton.IsChecked.Value)
            {
                this.pauseButton.IsChecked = false;
            }
            else
            {
                if(!this.player.IsPlaying)
                {
                    _ = this.player.PlayAsync(fromProgress : 0, toProgress : 1, looped : false);
                }
            }
        }

        #endregion
    }
}